function [K,T1,T2,Menovatel]=expid_dvaapident(t,u,y,language)

% Autor:    Bc. Pavel Doval
% Skolitel: Ing. Lubos Cirka, PhD.
%
% Dakujem Ing. Lubosovi Cirkovi za pochopenie a nezvycajne velku trpezlivost
% pri zodpovedani mojich otazok, vsetku pomoc, ktoru mi poskytol a celkove
% vedenie pri praci na tomto projekte

u_final = u(end);
u_start = u(1);

if u_start == u_final
   u_start = 0;
end

y = (y - y(1))./(u_final-u_start);

porovnanie = 0;
if y(1) >= y(end)
    y = -y;
    porovnanie = 1;
end

y_final = max(y);
y_start = min(y);

K = y_final - y_start;

delmat = diff(y)./diff(t);
indx = find(max(delmat)==delmat);
if length(indx)>1
    indx = indx(1);
end

bod_t1 = t(indx+1);
bod_y1 = y(indx+1);
bod_t2 = t(indx);
bod_y2 = y(indx);

a = (bod_y2 - bod_y1) / (bod_t2 - bod_t1);
b = bod_y2 - a*bod_t2;
Tu = ( y_start - b ) / a;
Tn = ( y_final - b ) / a - Tu;
f1kv = Tn / Tu;

k=[1.0001:0.0001:30];
f1k=1./((k.^(-k./(k-1)).*(1+k+(k./(k-1).*log(k))))-1);
f2k=k.^(k./(k-1));
if f1kv<min(f1k)
    if language == 'sk'
        errordlg('Metoda nie je vhodna na identifikaciu tohto systemu!', 'Error', 'modal');
        error('Pri identifikaci doslo k chybe. Koniec identifikacie.')
    end
    if language == 'en'
        errordlg('Identification method is not applicable to this system!', 'Error', 'modal');
        error('Identification failed! End of identification.')
    end
end
indx = find(f1kv<f1k);
f2k = f2k(indx(1));
k = k(indx(1));

T1 = Tn / f2k;
T2 = k * T1;
T12n = T1 * T2;
T12s = T1 + T2;
Menovatel = [T12n T12s 1];

if porovnanie == 1
    K = -K;
    y = -y;
end