function [K,T1,T2,SSO]=expid_dvaaprad(t,u,y,yf,ktore,language,depicture)

% Autor:    Bc. Pavel Doval
% Skolitel: Ing. Lubos Cirka, PhD.
%
% Dakujem Ing. Lubosovi Cirkovi za pochopenie a nezvycajne velku trpezlivost
% pri zodpovedani mojich otazok, vsetku pomoc, ktoru mi poskytol a celkove
% vedenie pri praci na tomto projekte

if length(ktore) == 1
    index = find(diff(u) ~= 0); index1 = index(ktore); index2 = index(ktore+1);
    tn = t(index1:index2)-t(index1); un = u(index1:index2); yn = yf(index1:index2)-y(index1);
    [K,T1,T2,Menovatel] = expid_dvaapident(tn,un,yn,language);
    yn = y(index1:index2)-y(index1);
else
    mindatu = []; cislo = 0; index = find(diff(u) ~= 0);
    for ix = 1:length(index)
        for jx = 1:length(ktore)
            if ix == ktore(jx)
                cislo = cislo + 1;
                hlp = index(ix+1) - index(ix); mindatu(cislo) = hlp;
            end
        end
    end
    mindatu = min(mindatu);
    [tn,un,yn,tx,yx] = expid_rozstrihaj(t,u,y,yf,ktore,mindatu); tn = round(1000000000000*tn)/1000000000000;
    [K,T1,T2,Menovatel] = expid_dvaapident(tx,[0 1],yx,language);
end

if isreal(K) == 0 | isreal(T1) == 0 | isreal(T2) == 0
    if language == 'sk'
        errordlg('Pri identifikaci doslo k chybe. Koniec identifikacie.', 'Error', 'modal');
        error('Pri identifikaci doslo k chybe. Koniec identifikacie.')
    end
    if language == 'en'
        errordlg('Identification failed! End of identification.', 'Error', 'modal');
        error('Identification failed! End of identification.')
    end
    return
end
error_size1 = size(sprintf('%s',char(T1)));
error_size2 = size(sprintf('%s',char(K)));
error_size3 = size(sprintf('%s',char(T2)));
if error_size1 == [1 0] & real(T1) > 0
    error_size1 = [1 1];
end
if error_size2 == [1 0] & real(K) > 0
    error_size2 = [1 1];
end
if error_size3 == [1 0] & real(T2) > 0
    error_size3 = [1 1];
end
if error_size1 == [1 0] | error_size2 == [1 0] | error_size3 == [1 0]
    if language == 'sk'
        errordlg('Pri identifikaci doslo k chybe. Koniec identifikacie.', 'Error', 'modal');
        error('Pri identifikaci doslo k chybe. Koniec identifikacie.')
    end
    if language == 'en'
        errordlg('Identification failed! End of identification.', 'Error', 'modal');
        error('Identification failed! End of identification.')
    end
    return
end
ttu = [tn, un]';
tty = [tn, yn]';
save vstup_u ttu;
save vstup_y tty;
% 
load_system('expid_porovnaj2')
set_param('expid_porovnaj2/cs1','Value',sprintf('[%d]',un(1)))
set_param('expid_porovnaj2/cs2','Value',sprintf('[%d]',yn(1)))
set_param('expid_porovnaj2/tf','Numerator',sprintf('[%d]',K))
set_param('expid_porovnaj2/tf','Denominator',sprintf('[%s]',num2str(Menovatel)))
sim('expid_porovnaj2',tn(end))
close_system('expid_porovnaj2',0)

delete vstup_u.mat; delete vstup_y.mat;

SSO = ((out.signals.values(:,1) - out.signals.values(:,2))'*(out.signals.values(:,1) -out.signals.values(:,2)));
SSO = SSO/length(find(diff(un) ~= 0));

if depicture == 1

    expid_xinputident
    
    subplot(3,1,3);
    plot(out.time,out.signals.values(:,2),'b',out.time,out.signals.values(:,1),'r')
    xlabel('t'), ylabel('y, yi')
    if language == 'sk'
        legend('Neznamy system','Identifikovany system')
    end
    if language == 'en'
        legend('Unknow system','Identified system')
    end

elseif depicture == 2
    
    figure(11235813)
    plot(out.time,out.signals.values(:,1),'r',out.time,out.signals.values(:,2),'b')
    if language == 'sk'
        title('Porovnanie neznameho a identifikovaneho systemu');
        xlabel('cas - t');
        ylabel('Vystupna velicina - y');
        legend('Identifikovany system','Neznamy system',0)
        set(gcf,'toolbar','none','name',sprintf('K = %6.4f, T1 = %6.4f, T2 = %6.4f, SSO = %6.4f',K,T1,T2,SSO),'numbertitle','off')
    end
    if language == 'en'
        title('Comparing unknow and identified system');
        xlabel('time - t');
        ylabel('output - y');
        legend('Identified system','Unknow system',0)
        set(gcf,'toolbar','none','name',sprintf('K = %6.4f, T1 = %6.4f, T2 = %6.4f, SSO = %6.4f',K,T1,T2,SSO),'numbertitle','off')
    end
    
else
    
    return
    
end