function [K,T,D,n,Menovatel]=expid_strejcident(t,u,y,nula,language)

% Autor:    Bc. Pavel Doval
% Skolitel: Ing. Lubos Cirka, PhD.
%
% Dakujem Ing. Lubosovi Cirkovi za pochopenie a nezvycajne velku trpezlivost
% pri zodpovedani mojich otazok, vsetku pomoc, ktoru mi poskytol a celkove
% vedenie pri praci na tomto projekte

u_final = u(end);
u_start = u(1);

if u_start == u_final
   u_start = 0;
end

y = (y - y(1))./(u_final-u_start);

porovnanie = 0;
if y(1) >= y(end)
    y = -y;
    porovnanie = 1;
end

K = ( y(end) - y(1) );
D0 = nula; index = find(t <= D0); 
if size(index) == [0 1]
    if language == 'sk'
        errordlg('Pri identifikacii doslo k chybe, zmente prosim hodnotu "Predpokladaneho dopravneho oneskorenia" na nissiu pripadne odlisnu hodnotu!', 'Error', 'modal');
        error('Pri identifikaci doslo k chybe. Koniec identifikacie.')
    end
    if language == 'en'
        errordlg('Identification failed, change please value of "Expected time delay" to a smaller or a different value!', 'Error', 'modal');
        error('Identification failed! End of identification.')
    end
end
DO = t(index(end));
tp = t(index(end):length(t))-D0;
yp = y(index(end):length(t));

y_final = max(yp);
y_start = min(yp);

delmat = diff(yp)./diff(tp);
indx = find(max(delmat)==delmat);
if length(indx)>1
    indx = indx(1);
end

bod_t1 = tp(indx+1);
bod_y1 = yp(indx+1);
bod_t2 = tp(indx);
bod_y2 = yp(indx);

a = (bod_y2 - bod_y1) / (bod_t2 - bod_t1);
b = bod_y2 - a*bod_t2;
Tu = ( y_start - b ) / a;
Tn = ( y_final - b ) / a - Tu;

n = [6 5 4 3 2 1]';
fn = [0.493 0.410 0.319 0.218 0.104 0.000]';
gn = [0.161 0.195 0.224 0.271 0.368 1.000]';

f = Tu / Tn;
%K = ( y_final - y_start );
index_f = find(fn<f);
if size(index_f) == [0 1]
    if language == 'sk'
        errordlg('Pri identifikacii doslo k chybe, zmente prosim hodnotu "Predpokladaneho dopravneho oneskorenia" na nissiu pripadne odlisnu hodnotu!', 'Error', 'modal');
        error('Pri identifikaci doslo k chybe. Koniec identifikacie.')
    end
    if language == 'en'
        errordlg('Identification failed, change please value of "Expected time delay" to a smaller or a different value!', 'Error', 'modal');
        error('Identification failed! End of identification.')
    end
end
fn = fn(index_f(1));
gn = gn(index_f(1));
n = n(index_f(1));
D = ( f - fn ) * Tn + D0;
T = Tn * gn;

a = [T 1];
b = conv(a,a);
c = conv(b,b);

if n == 1
    Menovatel = a;
elseif n == 2
    Menovatel = b;
elseif n == 3
    Menovatel = conv(a,b);
elseif n == 4
    Menovatel = conv(b,b);
elseif n == 5
    Menovatel = conv(c,a);
else
    Menovatel = conv(c,b);
end;

if porovnanie == 1
    K = -K;
    y = -y;
end