function retstr = mws_datafile(instruct)
retstr = char('');

mws_pathconf1
error_define = '00';

vtime = str2num(instruct.vtime); vinput = str2num(instruct.vinput); voutput = str2num(instruct.voutput);
if size(vtime) == [0 0] | size(vinput) == [0 0] |  size(voutput) == [0 0]
    error_define = '01';
    outstruct.error = error_define;
    templatefile = which('i_errorpage_zaver.php');
    retstr = htmlrep(outstruct, templatefile);
    return;
end
if round(vtime) ~= vtime | round(vinput) ~= vinput | round(voutput) ~= voutput
    error_define = '02';
    outstruct.error = error_define;
    templatefile = which('i_errorpage_zaver.php');
    retstr = htmlrep(outstruct, templatefile);
    return;
end

eval(sprintf('load %s;',instruct.subor));
eval(sprintf('mat = X%s;',instruct.subor));

mws_pathconf2

if  instruct.vektory == 'stlpec'
    t = mat(:,vtime);
    u = mat(:,vinput);
    y = mat(:,voutput);
else
    t = mat(vtime,:)';
    u = mat(vinput,:)';
    y = mat(voutput,:)';
end

uhelp = round(1000000000000000000*u)/1000000000000000000;
index = find(diff(uhelp) ~= 0);

if size(t) ~= size(u) | size(t) ~= size(y) | size(y) ~= size(u) | length(index) > 0.3*length(uhelp)
    error_define = '03';
    outstruct.error = error_define;
    templatefile = which('i_errorpage_zaver.php');
    retstr = htmlrep(outstruct, templatefile);
    return;
end

cpch = instruct.cpch;
max_cpch = length(find(diff(u)~=0))-1;

if isempty(cpch) | cpch == ' '
    cpch = [1:max_cpch];
elseif size(str2num(cpch)) == [0 0]
    error_define = '05';
    outstruct.error = error_define;
    templatefile = which('i_errorpage_zaver.php');
    retstr = htmlrep(outstruct, templatefile);
    return;
else
    cpch = eval(cpch);
end
if max(cpch) > max_cpch
    cpch = [1:max_cpch];
end

if instruct.filter == 'je'
    N = str2num(instruct.N); Wn = str2num(instruct.Wn);
    if size(N) == [0 0] | size(Wn) == [0 0]
        error_define = '01';
        outstruct.error = error_define;
        templatefile = which('i_errorpage_zaver.php');
        retstr = htmlrep(outstruct, templatefile);
        return;
    end
    if round(N) ~= N
        error_define = '02';
        outstruct.error = error_define;
        templatefile = which('i_errorpage_zaver.php');
        retstr = htmlrep(outstruct, templatefile);
        return;
    end
    if Wn > 1 | Wn < 0
        error_define = '04';
        outstruct.error = error_define;
        templatefile = which('i_errorpage_zaver.php');
        retstr = htmlrep(outstruct, templatefile);
        return;
    end
    [b, a] = butter(N, Wn);
    yf = filtfilt(b,a,y);
else
    yf = y;
end

di = round(10000000000*diff(t))/10000000000;
imax = max(di);
imin = min(di);
if imax ~= imin
    ttu = [t, u]';
    tty = [t, y]';
    ttfy = [t, yf]';
    texteval1 = sprintf('save %s_u ttu', instruct.mlid);
    texteval2 = sprintf('save %s_y tty', instruct.mlid);
    texteval3 = sprintf('save %s_yf ttfy', instruct.mlid);
    eval(texteval1);
    eval(texteval2);
    eval(texteval3);
    
    open_system('mws_schema_fixtime')
    set_param('mws_schema_fixtime/FromFile_u','FileName',sprintf('%s_u',instruct.mlid))
    set_param('mws_schema_fixtime/FromFile_y','FileName',sprintf('%s_y',instruct.mlid))
    set_param('mws_schema_fixtime/FromFile_yf','FileName',sprintf('%s_yf',instruct.mlid))
    sim('mws_schema_fixtime',t(end))
    close_system('mws_schema_fixtime',0)
    t = out.time;
    u = out.signals.values(:,1);
    y = out.signals.values(:,2);
    yf = out.signals.values(:,3);
end

switch instruct.method
    case '1rad'
    
        bod1 = str2num(instruct.bod1); bod2 = str2num(instruct.bod2);
        if size(bod1) == [0 0] | size(bod2) == [0 0]
            error_define = '01';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        if bod1 < 0 | bod1 > 100 | bod2 < 0 | bod2 > 100
            error_define = '06';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        [K,T,D,SSO,jpgname,error_define] = mws_jednarad(t,u,y,yf,bod1,bod2,cpch,instruct.mlid,error_define);

        outstruct.K = round(100000*K)/100000;
        outstruct.T = round(100000*T)/100000;
        outstruct.D = round(100000*D)/100000;
        outstruct.graf = jpgname;
        outstruct.SSO = SSO;
    
        templatefile = which('i_system1rad_zaver.php');
    
    case 'k2rad'
       
        [K,T,ksi,SSO,jpgname,error_define] = mws_dvakmrad(t,u,y,yf,cpch,instruct.mlid,error_define);

        outstruct.K = round(100000*K)/100000;
        outstruct.T = round(100000*T)/100000;
        outstruct.ksi = round(100000*ksi)/100000;
        outstruct.T12nx = round(100000*T*T)/100000;
        outstruct.T12sx = round(200000*T*ksi)/100000;
        outstruct.graf = jpgname;
        outstruct.SSO = SSO;
    
        templatefile = which('i_systemk2rad_zaver.php');
    
    case 'a2rad'
        
        [K,T1,T2,SSO,jpgname,error_define] = mws_dvaaprad(t,u,y,yf,cpch,instruct.mlid,error_define);

        outstruct.K = round(100000*K)/100000;
        outstruct.T1 = round(100000*T1)/100000;
        outstruct.T2 = round(100000*T2)/100000;
        outstruct.T12nx = round(100000*T1*T2)/100000;
        outstruct.T12sx = round(100000*(T1+T2))/100000;
        outstruct.graf = jpgname;
        outstruct.SSO = SSO;
    
        templatefile = which('i_systema2rad_zaver.php');
    
    case 'smrad'
        
        pdo = str2num(instruct.pdo);
        if size(pdo) == [0 0]
            error_define = '01';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        if pdo < 0
            error_define = '07';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        [K,T,D,n,SSO,jpgname,error_define]= mws_strejcrad(t,u,y,yf,pdo,cpch,instruct.mlid,error_define);

        outstruct.K = round(100000*K)/100000;
        outstruct.T = round(100000*T)/100000;
        outstruct.D = round(100000*D)/100000;
        outstruct.graf = jpgname;
        outstruct.SSO = SSO;
        outstruct.n = n;
    
        templatefile = which('i_systemsmrad_zaver.php');
    
    otherwise
        
        pdo = str2num(instruct.pdo);
        if size(pdo) == [0 0]
            error_define = '01';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        if pdo < 0
            error_define = '07';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        [K,T,D,n,SSO,jpgname,error_define]= mws_broidrad(t,u,y,yf,pdo,cpch,instruct.mlid,error_define);

        outstruct.K = round(100000*K)/100000;
        outstruct.T = round(100000*T)/100000;
        outstruct.D = round(100000*D)/100000;
        outstruct.graf = jpgname;
        outstruct.SSO = SSO;
        outstruct.n = n;
        
        a = [T 1]; b = [T/2 1]; c = [T/3 1]; d = [T/4 1]; e = [T/5 1]; f = [T/6 1];
        g = conv(a,b); h = conv(g,c); k = conv(h,d); l = conv(k,e); m = conv(l,f);

        if n==1
            templatefile = which('i_systembmrad_zaver1.php');
        elseif n==2
            a = 1.5 * T;
            b = 0.5 * T^2;
            templatefile = which('i_systembmrad_zaver2.php');
        elseif n==3
            a = 1.8333 * T;
            b = T^2;
            c = 0.1667 * T^3;
            templatefile = which('i_systembmrad_zaver3.php');
        elseif n==4
            a = 2.0833 * T;
            b = 1.4583 * T^2;
            c = 0.1467 * T^3;
            d = 0.0417 * T^4;
            templatefile = which('i_systembmrad_zaver4.php');
        elseif n==5
            a = 2.2833 * T;
            b = 1.875 * T^2;
            c = 0.7083 * T^3;
            d = 0.125 * T^4;
            e = 0.0083 * T^5;
            templatefile = which('i_systembmrad_zaver5.php');
        else
            a = 2.45 * T;
            b = 2.2556 * T^2;
            c = 1.0208 * T^3;
            d = 0.2431 * T^4;
            e = 0.0292 * T^5;
            f = 0.0014 * T^6;
            templatefile = which('i_systembmrad_zaver6.php');
        end;
        
        outstruct.a = round(100000*a)/100000;
        outstruct.b = round(100000*b)/100000;
        outstruct.c = round(100000*c)/100000;
        outstruct.d = round(100000*d)/100000;
        outstruct.e = round(100000*e)/100000;
        outstruct.f = round(100000*f)/100000;
    
end

wscleanup('*.jpg',1);
wscleanup('*.mat',1);

if error_define ~= '00'
    outstruct.error = error_define;
    templatefile = which('i_errorpage_zaver.php');
end        
retstr = htmlrep(outstruct, templatefile);