function retstr = mws_datawrite(instruct)
retstr = char('');

%instruct
error_define = '00';
mws_pathconf2

%%
%testovanie
%%
yinf = str2num(instruct.yinf); uinf = str2num(instruct.uinf);
yzer = str2num(instruct.yzer); uzer = str2num(instruct.uzer);
if size(yinf) == [0 0] | size(uinf) == [0 0] | size(yzer) == [0 0] | size(uzer) == [0 0]
    error_define = '01';
    outstruct.error = error_define;
    templatefile = which('i_errorpage_zaver.php');
    retstr = htmlrep(outstruct, templatefile);
    return;
end
%%

switch instruct.method
    case '1rad'
        
        %%
        %testovanie
        %%
        bod1t = str2num(instruct.bod1t); bod2t = str2num(instruct.bod2t);
        bod1y = str2num(instruct.bod1y); bod2y = str2num(instruct.bod2y);
        if size(bod1y) == [0 0] | size(bod2y) == [0 0] | size(bod1t) == [0 0] | size(bod2t) == [0 0]
            error_define = '01';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        %%
        
        K = (yinf - yzer) / (uinf - uzer);
        T = (bod2t - bod1t) / log(( K - bod1y ) / ( K - bod2y ));
        x = (log( ( K - bod1y ) / K ) / log( ( K - bod2y ) / K ) );
        D = ( bod2t * x - bod1t ) / ( x - 1 );
        if D < 0
            D = 0;
        end;
        
        open_system('mws_schema_datawrite');
        set_param('mws_schema_datawrite/Funkcia','Numerator',num2str(K));
        set_param('mws_schema_datawrite/Skok','Before',instruct.uzer);
        set_param('mws_schema_datawrite/Skok','After',instruct.uinf);
        set_param('mws_schema_datawrite/Transport','DelayTime',num2str(D));
        set_param('mws_schema_datawrite/Funkcia','Denominator',sprintf('[%d 1]',T));
        sim('mws_schema_datawrite', str2num(instruct.bod2t)/0.7+3+D);
        close_system('mws_schema_datawrite',0)

        wscleanup('*.mat',1);
        wscleanup('*.jpg',1);

        fout = figure('visible','off');
        plot(tout,yout,'r');
        title('Znazornenie identifikovaneho systemu');
        xlabel('cas - t'); ylabel('Vystupna velicina - y');
        legend('Identifikovany system',0);
        jpgname = sprintf('%s.jpg',instruct.mlid);
        drawnow;
        wsprintjpeg(fout,jpgname);
        close('all');

        outstruct.K = round(100000*K)/100000;
        outstruct.T = round(100000*T)/100000;
        outstruct.D = round(100000*D)/100000;
        outstruct.graf = jpgname;
        outstruct.SSO = 'Nie je mozny vypocet.';
    
        templatefile = which('i_system1rad_zaver.php');
    
    case 'k2rad'
       
        %%
        %testovanie
        %%
        bod1t = str2num(instruct.bod1t); bod2t = str2num(instruct.bod2t);
        bod1y = str2num(instruct.bod1y); bod2y = str2num(instruct.bod2y);
        if size(bod1y) == [0 0] | size(bod2y) == [0 0] | size(bod1t) == [0 0] | size(bod2t) == [0 0]
            error_define = '01';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        %%
        
        M = ( bod1y - bod2y ) / bod1y;
        m = sqrt( 3.14^2 + ( log( M ) )^2 );
        r = abs( log( M ) / m );
        P = sqrt( 1 - r^2 );
        om = 3.14 / ( ( bod2t - bod1t ) * P );
        T = 1 / om;
        K = bod1y / ( 1 + M );
        D = 0;

        a = T^2;
        b = 2 * T * r;

        open_system('mws_schema_datawrite');
        set_param('mws_schema_datawrite/Funkcia','Numerator',num2str(K));
        set_param('mws_schema_datawrite/Skok','Before',instruct.uzer);
        set_param('mws_schema_datawrite/Skok','After',instruct.uinf);
        set_param('mws_schema_datawrite/Transport','DelayTime',num2str(D));
        set_param('mws_schema_datawrite/Funkcia','Denominator',sprintf('[%d %d 1]',a,b));
        sim('mws_schema_datawrite', str2num(instruct.bod2t)*5);

        wscleanup('*.mat',1);
        wscleanup('*.jpg',1);

        fout = figure('visible','off');
        plot(tout,yout,'r');
        title('Znazornenie identifikovaneho systemu');
        xlabel('cas - t'); ylabel('Vystupna velicina - y');
        legend('Identifikovany system',0);
        jpgname = sprintf('%s.jpg',instruct.mlid);
        drawnow;
        wsprintjpeg(fout,jpgname);
        close('all');

        outstruct.K = round(100000*K)/100000;
        outstruct.T = round(100000*T)/100000;
        outstruct.ksi = round(100000*r)/100000;
        outstruct.T12nx = round(100000*T*T)/100000;
        outstruct.T12sx = round(200000*T*r)/100000;
        outstruct.graf = jpgname;
        outstruct.SSO = 'Nie je mozny vypocet.';
    
        templatefile = which('i_systemk2rad_zaver.php');
    
    case 'a2rad'
        
        %%
        %testovanie
        %%
        Tn = str2num(instruct.Tn); Tu = str2num(instruct.Tu);
        if size(Tn) == [0 0] | size(Tu) == [0 0]
            error_define = '01';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        %%
        
        k=[1.0001:0.0001:30];
        f1k=1./((k.^(-k./(k-1)).*(1+k+(k./(k-1).*log(k))))-1);
        f2k=k.^(k./(k-1));

        K = ( yinf - yzer ) / ( uinf - uzer );
        f1kv = Tn / Tu;

        indx = find(f1kv<f1k);
        f2k = f2k(indx(1));
        k = k(indx(1));

        T1 = Tn / f2k;
        T2 = k * T1;
        T12n = T1 * T2;
        T12s = T1 + T2;
        D = 0;

        open_system('mws_schema_datawrite');
        set_param('mws_schema_datawrite/Funkcia','Numerator',num2str(K));
        set_param('mws_schema_datawrite/Skok','Before',instruct.uzer);
        set_param('mws_schema_datawrite/Skok','After',instruct.uinf);
        set_param('mws_schema_datawrite/Transport','DelayTime',num2str(D));
        set_param('mws_schema_datawrite/Funkcia','Denominator',sprintf('[%d %d 1]',T12n,T12s));
        sim('mws_schema_datawrite', str2num(instruct.Tn)*4);

        wscleanup('*.mat',1);
        wscleanup('*.jpg',1);

        fout = figure('visible','off');
        plot(tout,yout,'r');
        title('Znazornenie identifikovaneho systemu');
        xlabel('cas - t'); ylabel('Vystupna velicina - y');
        legend('Identifikovany system',0);
        jpgname = sprintf('%s.jpg',instruct.mlid);
        drawnow;
        wsprintjpeg(fout,jpgname);
        close('all');

        outstruct.K = round(100000*K)/100000;
        outstruct.T1 = round(100000*T1)/100000;
        outstruct.T2 = round(100000*T2)/100000;
        outstruct.T12nx = round(100000*T1*T2)/100000;
        outstruct.T12sx = round(100000*(T1+T2))/100000;
        outstruct.graf = jpgname;
        outstruct.SSO = 'Nie je mozny vypocet.';
    
        templatefile = which('i_systema2rad_zaver.php');
    
    case 'smrad'

        %%
        %testovanie
        %%
        Tn = str2num(instruct.Tn); Tu = str2num(instruct.Tu);
        if size(Tn) == [0 0] | size(Tu) == [0 0]
            error_define = '01';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        %%
        
        n = [6 5 4 3 2 1]';
        fn = [0.493 0.410 0.319 0.218 0.104 0.000]';
        gn = [0.161 0.195 0.224 0.271 0.368 1.000]';

        f = round(1000 * Tu / Tn)/1000;
        K = ( yinf - yzer ) / ( uinf - uzer );
        index_f = find(fn<f);
        fn = fn(index_f(1));
        gn = gn(index_f(1));
        n = n(index_f(1));
        D = ( f - fn ) * Tn;
        T = Tn * gn;

        a = [T 1];
        b = conv(a,a);
        c = conv(b,b);
        
        if n == 1
            Menovatel = a;
        elseif n == 2
            Menovatel = b;
        elseif n == 3
            Menovatel = conv(a,b);
        elseif n == 4
            Menovatel = conv(b,b);
        elseif n == 5
            Menovatel = conv(c,a);
        else
            Menovatel = conv(c,b);
        end;
        
        open_system('mws_schema_datawrite');
        set_param('mws_schema_datawrite/Skok','Before',instruct.uzer);
        set_param('mws_schema_datawrite/Skok','After',instruct.uinf);
        set_param('mws_schema_datawrite/Transport','DelayTime',num2str(D));
        set_param('mws_schema_datawrite/Funkcia','Denominator',sprintf('[%s]',num2str(Menovatel)));
        set_param('mws_schema_datawrite/Funkcia','Numerator',num2str(K));
        sim('mws_schema_datawrite', str2num(instruct.Tn)*2.5);
        
        wscleanup('*.mat',1);
        wscleanup('*.jpg',1);
        
        fout = figure('visible','off');
        plot(tout,yout,'r');
        title('Znazornenie identifikovaneho systemu');
        xlabel('cas - t'); ylabel('Vystupna velicina - y');
        legend('Identifikovany system',0);
        jpgname = sprintf('%s.jpg',instruct.mlid);
        drawnow;
        wsprintjpeg(fout,jpgname);
        close('all');

        outstruct.K = round(100000*K)/100000;
        outstruct.T = round(100000*T)/100000;
        outstruct.D = round(100000*D)/100000;
        outstruct.n = n;
        outstruct.graf = jpgname;
        outstruct.SSO = 'Nie je mozny vypocet.';
    
        templatefile = which('i_systemsmrad_zaver.php');
    
    otherwise
        
        %%
        %testovanie
        %%
        Tn = str2num(instruct.Tn); Tu = str2num(instruct.Tu);
        if size(Tn) == [0 0] | size(Tu) == [0 0]
            error_define = '01';
            outstruct.error = error_define;
            templatefile = which('i_errorpage_zaver.php');
            retstr = htmlrep(outstruct, templatefile);
            return;
        end
        %%
        
        n = [6 5 4 3 2 1]';
        fn = [0.493 0.410 0.319 0.218 0.104 0.000]';
        gn = [0.161 0.195 0.224 0.271 0.368 1.000]';

        f = round(1000 * Tu / Tn)/1000;
        K = ( yinf - yzer ) / ( uinf - uzer );
        index_f = find(fn<f);
        fn = fn(index_f(1));
        gn = gn(index_f(1));
        n = n(index_f(1));
        D = ( f - fn ) * Tn;
        T = Tn * gn;

        a = [T 1]; b = [T/2 1]; c = [T/3 1]; d = [T/4 1]; e = [T/5 1]; f = [T/6 1];
        g = conv(a,b); h = conv(g,c); k = conv(h,d); l = conv(k,e); m = conv(l,f);

        if n==1
            Menovatel = a;
        elseif n==2
            Menovatel = g;
        elseif n==3
            Menovatel = h;
        elseif n==4
            Menovatel = k;
        elseif n==5
            Menovatel = l;
        else
            Menovatel = m;
        end;
        
        open_system('mws_schema_datawrite');
        set_param('mws_schema_datawrite/Skok','Before',instruct.uzer);
        set_param('mws_schema_datawrite/Skok','After',instruct.uinf);
        set_param('mws_schema_datawrite/Transport','DelayTime',num2str(D));
        set_param('mws_schema_datawrite/Funkcia','Denominator',sprintf('[%s]',num2str(Menovatel)));
        set_param('mws_schema_datawrite/Funkcia','Numerator',num2str(K));
        sim('mws_schema_datawrite', str2num(instruct.Tn)*2.5);
        
        wscleanup('*.mat',1);
        wscleanup('*.jpg',1);
        
        fout = figure('visible','off');
        plot(tout,yout,'r');
        title('Znazornenie identifikovaneho systemu');
        xlabel('cas - t'); ylabel('Vystupna velicina - y');
        legend('Identifikovany system',0);
        jpgname = sprintf('%s.jpg',instruct.mlid);
        drawnow;
        wsprintjpeg(fout,jpgname);
        close('all');

        outstruct.K = round(100000*K)/100000;
        outstruct.T = round(100000*T)/100000;
        outstruct.D = round(100000*D)/100000;
        outstruct.graf = jpgname;
        outstruct.SSO = 'Nie je mozny vypocet.';
        outstruct.n = n;
        
        if n==1
            templatefile = which('i_systembmrad_zaver1.php');
        elseif n==2
            a = 1.5 * T;
            b = 0.5 * T^2;
            templatefile = which('i_systembmrad_zaver2.php');
        elseif n==3
            a = 1.8333 * T;
            b = T^2;
            c = 0.1667 * T^3;
            templatefile = which('i_systembmrad_zaver3.php');
        elseif n==4
            a = 2.0833 * T;
            b = 1.4583 * T^2;
            c = 0.1467 * T^3;
            d = 0.0417 * T^4;
            templatefile = which('i_systembmrad_zaver4.php');
        elseif n==5
            a = 2.2833 * T;
            b = 1.875 * T^2;
            c = 0.7083 * T^3;
            d = 0.125 * T^4;
            e = 0.0083 * T^5;
            templatefile = which('i_systembmrad_zaver5.php');
        else
            a = 2.45 * T;
            b = 2.2556 * T^2;
            c = 1.0208 * T^3;
            d = 0.2431 * T^4;
            e = 0.0292 * T^5;
            f = 0.0014 * T^6;
            templatefile = which('i_systembmrad_zaver6.php');
        end;
        
        outstruct.a = round(100000*a)/100000;
        outstruct.b = round(100000*b)/100000;
        outstruct.c = round(100000*c)/100000;
        outstruct.d = round(100000*d)/100000;
        outstruct.e = round(100000*e)/100000;
        outstruct.f = round(100000*f)/100000;
        
end

retstr = htmlrep(outstruct, templatefile);