function [K,T1,T2,SSO,jpgname,error_define]=mws_dvaaprad(t,u,y,yf,ktore,mlid,error_define)

% Autor:    Bc. Pavel Doval
% Skolitel: Ing. Lubos Cirka, PhD.
%
% Dakujem Ing. Lubosovi Cirkovi za pochopenie a nezvycajne velku trpezlivost
% pri zodpovedani mojich otazok, vsetku pomoc, ktoru mi poskytol a celkove
% vedenie pri praci na tomto projekte

if length(ktore) == 1
    index = find(diff(u) ~= 0); index1 = index(ktore); index2 = index(ktore+1);
    tn = t(index1:index2)-t(index1); un = u(index1:index2); yn = yf(index1:index2)-y(index1);
    [K,T1,T2,Menovatel,error_define] = mws_dvaapident(tn,un,yn,error_define);
    yn = y(index1:index2)-y(index1);
else
    mindatu = []; cislo = 0; index = find(diff(u) ~= 0);
    for ix = 1:length(index)
        for jx = 1:length(ktore)
            if ix == ktore(jx)
                cislo = cislo + 1;
                hlp = index(ix+1) - index(ix); mindatu(cislo) = hlp;
            end
        end
    end
    mindatu = min(mindatu);
    [tn,un,yn,tx,yx] = mws_rozstrihaj(t,u,y,yf,ktore,mindatu); tn = round(1000000000000*tn)/1000000000000;
    [K,T1,T2,Menovatel,error_define] = mws_dvaapident(tx,[0 1],yx,error_define);
end

if isreal(K) == 0 | isreal(T1) == 0 | isreal(T2) == 0
    T1 = 0; K = 0; T2 = 0; jpgname = 'neni'; SSO = 0;
    error_define = '11';
    return;
end
error_size1 = size(sprintf('%s',char(T1)));
error_size2 = size(sprintf('%s',char(K)));
error_size3 = size(sprintf('%s',char(T2)));
if error_size1 == [1 0] & real(T1) > 0
    error_size1 = [1 1];
end
if error_size2 == [1 0] & real(K) > 0
    error_size2 = [1 1];
end
if error_size3 == [1 0] & real(T2) > 0
    error_size3 = [1 1];
end
if error_size1 == [1 0] | error_size2 == [1 0] | error_size3 == [1 0]
    T1 = 0; K = 0; T2 = 0; jpgname = 'neni'; SSO = 0;
    error_define = '11';
    return;
end
ttu = [tn, un]';
tty = [tn, yn]';
texteval1 = sprintf('save %s_u ttu', mlid);
texteval2 = sprintf('save %s_y tty', mlid);
eval(texteval1);
eval(texteval2);
% 
load_system('mws_schema_datafile')
set_param('mws_schema_datafile/FromFile_u','FileName',sprintf('%s_u', mlid))
set_param('mws_schema_datafile/FromFile_yf','FileName',sprintf('%s_y', mlid))
set_param('mws_schema_datafile/cs1','Value',sprintf('[%d]',un(1)))
set_param('mws_schema_datafile/cs2','Value',sprintf('[%d]',yn(1)))
set_param('mws_schema_datafile/tf','Numerator',sprintf('[%d]',K))
set_param('mws_schema_datafile/tf','Denominator',sprintf('[%s]',num2str(Menovatel)))
set_param('mws_schema_datafile/Dtime','DelayTime',sprintf('[%d]',0))
sim('mws_schema_datafile',tn(end))
close_system('mws_schema_datafile',0)

SSO = ((out.signals.values(:,1) - out.signals.values(:,2))'*(out.signals.values(:,1) -out.signals.values(:,2)));
SSO = SSO/length(find(diff(un) ~= 0));

wscleanup('ml*.jpg',1);
wscleanup('*.mat',1);

fout = figure('visible','off');
plot(out.time,out.signals.values(:,1),'r',out.time,out.signals.values(:,2),'b')
title('Porovnanie neznameho a identifikovaneho systemu');
xlabel('cas - t'); ylabel('Vystupna velicina - y');
legend('Identifikovany system','Neznamy system',0)
jpgname = sprintf('%s.jpg',mlid);
drawnow;
wsprintjpeg(fout,jpgname);
close('all');